#ifndef HARKTOOL4_UTILS_BOOST_HPP
#define HARKTOOL4_UTILS_BOOST_HPP

#ifndef Q_MOC_RUN
#include <boost/optional.hpp>
#include <boost/filesystem.hpp>
#endif

/** @brief システムのテンポラリディレクトリにユニークな名前のディレクトリを生成し、パスを返す.
 * システムのテンポラリディレクトリとは、例えば /tmp など。
 * そこへユニークな名前を持つディレクトリを一つ作り、そのディレクトリへのパスを返す。
 * 同名のディレクトリが既に存在するという理由でディレクトリ生成ができなかった場合、
 * retryで指定される回数だけディレクトリ生成を試みる。
 * @param retry ディレクトリ作成の試行回数
 */
boost::filesystem::path CreateTemporaryDirectory(size_t retry = 3);

#endif // HARKTOOL4_UTILS_BOOST_HPP
